## ros-melodic-cloudwatch-logs-common 1.1.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(cloudwatch_logs_common)
set(CLOUDWATCH_LOGS_COMMON_VERSION 1.1.0)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()
# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

# Enable strict compiler flags if possible.
include(CheckCXXCompilerFlag)
# Removed -Wmissing-declarations until gmock is ignored
set(FLAGS -pedantic -Wno-long-long -Wall -Wextra -Wcast-qual -Wformat -Wwrite-strings -Wcast-align -Wno-error=cast-align)
foreach(FLAG ${FLAGS})
  check_cxx_compiler_flag(${FLAG} R${FLAG})
  if(${R${FLAG}})
    set(WARNING_CXX_FLAGS "${WARNING_CXX_FLAGS} ${FLAG}")
  endif()
endforeach()

if(NOT DEFINED CXX_DISABLE_WERROR)
  set(WARNING_CXX_FLAGS "-Werror ${WARNING_CXX_FLAGS}")
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WARNING_CXX_FLAGS}")

find_package(dataflow_lite REQUIRED)
find_package(file_management REQUIRED)
find_package(aws_common REQUIRED)

if(AWSSDK_FOUND)
  set(SERVICE logs)
  AWSSDK_DETERMINE_LIBS_TO_LINK(SERVICE OUTPUT)
  link_directories("${AWSSDK_LIB_DIR}")
endif()

set(ALL_SRC_FILES
    src/log_batcher.cpp
    src/log_service_factory.cpp
    src/utils/cloudwatch_logs_facade.cpp
    src/utils/log_file_manager.cpp
    src/log_service_factory.cpp
    src/log_publisher.cpp)

add_library(${PROJECT_NAME} SHARED ${ALL_SRC_FILES})
target_link_libraries(${PROJECT_NAME} ${OUTPUT} ${file_management_LIBRARIES} ${dataflow_lite_LIBRARIES} stdc++fs)
target_include_directories(${PROJECT_NAME}
        PRIVATE ${AWSSDK_INCLUDE_DIRS}
        include ${aws_common_INCLUDE_DIRS} ${file_management_INCLUDE_DIRS} ${dataflow_lite_INCLUDE_DIRS})
target_include_directories(${PROJECT_NAME} PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

#############
## Install ##
#############
install(TARGETS ${PROJECT_NAME}
        EXPORT "${PROJECT_NAME}-targets"
        ARCHIVE DESTINATION lib
        LIBRARY DESTINATION lib
        RUNTIME DESTINATION bin)

## Mark cpp header files for installation
install(DIRECTORY include/
        DESTINATION include)

export(TARGETS ${PROJECT_NAME}
        FILE "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-targets.cmake")
export(PACKAGE ${PROJECT_NAME})

CONFIGURE_FILE(${PROJECT_NAME}Config.cmake.in
               ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake @ONLY)
CONFIGURE_FILE(${PROJECT_NAME}ConfigVersion.cmake.in
               ${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake @ONLY)

INSTALL(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake DESTINATION share/${PROJECT_NAME}/cmake)
INSTALL(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake DESTINATION share/${PROJECT_NAME}/cmake)
INSTALL(EXPORT ${PROJECT_NAME}-targets DESTINATION share/${PROJECT_NAME}/cmake)


#############
## Testing ##
#############

enable_testing()
find_common_test_packages()
if(GMOCK_LIBRARY)

  macro(link_test_target target_name)
    if(TARGET ${target_name})
      target_include_directories("${target_name}" PRIVATE ${HEADERS_FOR_TESTS})
      target_link_libraries("${target_name}" ${LIBS_FOR_TESTS})
    endif()
  endmacro()

  add_common_gtest(test_cloudwatch_logs_common
        test/main_test.cpp
        test/log_publisher_test.cpp
        test/cloudwatch_facade_test.cpp
        )

  add_common_gtest(test_pipelines
          test/pipeline_test.cpp
          )

  add_common_gtest(test_log_batch
          test/log_batch_test.cpp
          )

  set(LIBS_FOR_TESTS
          ${GTEST_LIBRARIES}
          pthread
          ${GMOCK_LIBRARY}
          ${PROJECT_NAME}
          )

  set(HEADERS_FOR_TESTS
          PRIVATE include
          PRIVATE ${aws_common_INCLUDE_DIRS}
          PUBLIC ${PROJECT_SOURCE_DIR}/test/include
          )

  link_test_target(test_cloudwatch_logs_common)
  link_test_target(test_pipelines)
  link_test_target(test_log_batch)

endif()

=== debian/changelog ===
ros-melodic-cloudwatch-logs-common (1.1.5-1stretch) stretch; urgency=high

  * Limit the rate of cloudwatch log uploading to match API service limits (#61 <https://github.com/aws-robotics/cloudwatch-common/issues/61>)
    * Limit the rate of publishing to PutLogEvents by delaying calls inside the CloudWathLogsFacade
  * Contributors: Emerson Knapp

 -- AWS RoboMaker <ros-contributions@amazon.com>  Wed, 14 Oct 2020 07:00:00 -0000

ros-melodic-cloudwatch-logs-common (1.1.4-1stretch) stretch; urgency=high

  * Correct seconds to milliseconds (#59 <https://github.com/aws-robotics/cloudwatch-common/issues/59>)
  * Add AWS logging to batch tests (#58 <https://github.com/aws-robotics/cloudwatch-common/issues/58>)
  * Allow user to automatically delete CloudWatch logs in batch that are > 14 days old (#56 <https://github.com/aws-robotics/cloudwatch-common/issues/56>)
    * move docstring and don't break loop
    * call fileUploadComplete
    * modify struct and add tests
    * add tests and change 2 week wording to old
    * Add lock to discard stale data container
    * extend stale data protection
    * remove setter
    * Reduce lock_guard scope
  * add error for invalid log batch (#52 <https://github.com/aws-robotics/cloudwatch-common/issues/52>)
    * add error for invalid log batch
    * modify logic
    * change to long instead of time
    * fix syntax
    * separate to function
    * change function order
    * add unit test
    * Add file manager test to CMakeList
    * file manager unit test
    * typo
    * add test log file manager class
    * modify filetest class and add unit test
    * add test publisher
    * debug
    * add validate batch function:
    * organize tuple
    * for loop to add valid data
    * pair
    * new priority queue
    * back to tuple
    * add outdated check
    * modify logic
    * modify test and pq
    * modify tests
    * add readbatch mock
    * add headers
    * remove data token
    * separate to new log_batch test file
    * add log comparison function
    * update test
    * fix typos
    * update batch test
    * remove outdated, fix timestamp
    * add > 24 hour log
    * remove utility
    * fix typo
    * changes based on review
    * modify macro
    * modify test
    * modify log_data
    * typo
    * add testfilemanagerstrategy
    * change logfile to datamanager & more
    * mock read function
    * update read and write functions
    * modify tests based on review
    * add batch_data validation
    * remove unnecessary headers
    * add test fixture
    * update test fixtures
    * updates based on review
  * Bumping version to match bloom release (#51 <https://github.com/aws-robotics/cloudwatch-common/issues/51>)
    Bumping version to 1.1.3
  * Fix linting issues found by clang-tidy 6.0 (#50 <https://github.com/aws-robotics/cloudwatch-common/issues/50>)
    * clang-tidy fixes
    * revert explicit constructor declarations to maintain API compatbility
    * clang-tidy linting issues fixed manually
    * fix unit tests build break
  * Increase package version numbers to 1.1.2 (#44 <https://github.com/aws-robotics/cloudwatch-common/issues/44>)
  * Contributors: Jesse Ikawa, Miaofei Mei, Nick Burek, Ragha Prasad

 -- AWS RoboMaker <ros-contributions@amazon.com>  Thu, 17 Sep 2020 07:00:00 -0000

ros-melodic-cloudwatch-logs-common (1.1.1-1stretch) stretch; urgency=high

  * Disable error on cast-align warning to support ARMhf builds (#41 <https://github.com/aws-robotics/cloudwatch-common/issues/41>)
    * Remove -Wcast-align flag to support ARMhf builds
    *  - bumped versions to 1.1.1
    - restored cast-align, but added as a warning
    - removed unused headers
    * Removed duplicate Werror
  * modify changelist to be compatible with catkin_generate_changelog (#39 <https://github.com/aws-robotics/cloudwatch-common/issues/39>)
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
  * Merge pull request #36 <https://github.com/aws-robotics/cloudwatch-common/issues/36> from aws-robotics/guard_test_libs
    Added guards for test libraries
  * Added guards for test libraries
  * Offline logs feature (#34 <https://github.com/aws-robotics/cloudwatch-common/issues/34>)
    * Add file manager and upload complete callback
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Fixed merge conflict
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add file manager test
    Still deciding if the write should just go in the FileManagerStrategy.
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add FileManager to log manager factory
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add generic file upload logic
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add reading, discovery and rotation to FileManagerStrategy
    - Add function getFileToRead that returns the best file to start reading
    from when sending data from the file to CloudWatch.
    - Add function discoverStoredFiles which finds all files in the
    storage directory and keeps them, in case there were offline logs still
    hanging around from a previous run.
    - Add rotateActiveFile which creates a new file to write to. This is
    used when we want to read from the current active file, or when the file
    size limit has been reached.
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add file management system.
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Link file management with publisher
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add test for file management system
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add reading and writing to FileManagerStrategy
    - This way the file manager strategy can handle all the core file data
    stuff, keeping track of the size of the active file and rotating it when
    neccessary.
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * cleanup
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>


=== debian/control ===
Source: ros-melodic-cloudwatch-logs-common
Section: misc
Priority: optional
Maintainer: AWS RoboMaker <ros-contributions@amazon.com>
Build-Depends: debhelper (>= 9.0.0), cmake, google-mock, libgtest-dev, ros-melodic-aws-common, ros-melodic-catkin, ros-melodic-dataflow-lite, ros-melodic-file-management
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-cloudwatch-logs-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-aws-common, ros-melodic-dataflow-lite, ros-melodic-file-management
Description: AWS CloudWatch management library used by ROS1/2 node to publish logs to CloudWatch service

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-cloudwatch-logs-common//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
